﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace ColumnWidth
{
	public class DataSourceTableInformation : INotifyPropertyChanged
	{
		public DataSourceTableInformation(
			string displayName,
			string groupBy,
			IEnumerable<object> dataTable )
		{
			DisplayName = displayName;
			GroupBy = groupBy;
			DataTable = dataTable;
		}

		public string DisplayName
		{
			get
			{
				return displayName;
			}
			set
			{
				if ( displayName != value )
				{
					displayName = value;
					NotifyPropertyChanged( "DisplayName" );
				}
			}
		}
		private string displayName;

		public string GroupBy
		{
			get
			{
				return groupBy;
			}
			set
			{
				if ( groupBy != value )
				{
					groupBy = value;
					NotifyPropertyChanged( "GroupBy" );
				}
			}
		}
		private string groupBy;

		public IEnumerable<object> DataTable
		{
			get
			{
				return dataTable;
			}
			set
			{
				if ( dataTable != value )
				{
					dataTable = value;
					NotifyPropertyChanged( "DataTable" );
				}
			}
		}
		private IEnumerable<object> dataTable;

		#region Implementation of INotifyPropertyChanged

		public event PropertyChangedEventHandler PropertyChanged;

		protected virtual void NotifyPropertyChanged( string propertyName )
		{
			PropertyChangedEventHandler handler = PropertyChanged;
			if ( handler != null )
				handler( this, new PropertyChangedEventArgs( propertyName ) );
		}

		#endregion // Implementation of INotifyPropertyChanged
	}
}
